BEGIN {
  in_comment="no";
  testIt="no";
  #testIt="yes";
}
{
  theLine= $0;
  if( testIt == "yes" ) {
    printf( "%d:%s\n", NR, theLine);
  }
  dashFound= index( theLine, "#" );
  if( dashFound >0) {
    includeFound= index( theLine, "include " );
    if( testIt == "yes" ) {
      printf( "IncludeFound %d\n", includeFound);
    }
    if( includeFound > 0) {
      theLine="";
    }
    defineFound= index( theLine, "define " );
    if( testIt == "yes" ) {
      printf( "DefineFound %d\n", defineFound);
    }
    if( defineFound > 0) {
      theLine="";
    }
  }
  if( testIt == "yes" ) {
    printf( "%d:%s\n", NR, theLine);
  }
  if( in_comment == "no" ) {
    # look for the begin of a comment /*
    theCommentBeginsHere= index( theLine, "/*" );
    if( theCommentBeginsHere > 0) {
      if( testIt == "yes" ) {
        printf( "%d:%s\n", NR, theLine);
        printf( "%d:123456789_123456789_123456789_123456789_123456789_123456789_\n", NR);
        printf( "CommentBegins found:%d\n", theCommentBeginsHere);
      }
      # look for comment end in the same line
      restOfTheLine= substr( theLine, theCommentBeginsHere+ 2);
      # look for */
      theCommentEndsHere= index( restOfTheLine, "*/" );
      if( theCommentEndsHere > 0) {
        firstPartOfTheLine= substr( theLine, 1, theCommentBeginsHere- 1);
        if( testIt == "yes" ) {
          printf( "First Part Of The Line B:%s:\n", firstPartOfTheLine);
        }
        tempBuffer= restOfTheLine;
        lastPartOfTheLine= substr( tempBuffer, theCommentEndsHere+ 2);
        lengthOfTheLastOfTheLine= length( lastPartOfTheLine);
        if( testIt == "yes" ) {
          printf( "Last Part Of The Line:%s:\n", lastPartOfTheLine);
          printf( "Length Of The Last Of The Line=%d\n", lengthOfTheLastOfTheLine);
        }
        # space at the end of firstPartOfTheLine will be removed
        lengthOfTheFirstPart= length( firstPartOfTheLine);
        letter= substr( firstPartOfTheLine, lengthOfTheFirstPart, 1);
        while( letter == " " ) {
          restOfTheFirstPart= substr( firstPartOfTheLine, 1, lengthOfTheFirstPart- 1);
          firstPartOfTheLine= restOfTheFirstPart;
          if( testIt == "yes" ) {
            printf( "First Part Of The Line w:%s:\n", firstPartOfTheLine);
          }
          lengthOfTheFirstPart= length( firstPartOfTheLine);
          letter= substr( firstPartOfTheLine, lengthOfTheFirstPart, 1);
        }
        if( testIt == "yes" ) {
          printf( "First Part Of The Line E:%s:\n", firstPartOfTheLine);
        }
        # output the first part
        outputLine= firstPartOfTheLine;
        #printf( "%s", firstPartOfTheLine);
        if( lengthOfTheLastOfTheLine > 0) {
          # output the last part
          outputLine= outputLine+ lastPartOfTheLine;
        }
      } else {
        outputLine= "";
        in_comment="ja";
      }
    } else {
      # look for //
      the2areBeginningHere= index( theLine, "//" );
      if( the2areBeginningHere > 0) {
        if( testIt == "yes" ) {
          printf( "%d\n", the2areBeginningHere);
        }
        # check if http://www.....
        letterBefore= substr( theLine, the2areBeginningHere- 1, 1);
        if( letterBefore == ":" ) {
          if( testIt == "yes" ) {
            printf( ": is before \\\\\n" );
          }
          # don't modify the line
        } else {
          # check if "//"
          letterBefore= substr( theLine, the2areBeginningHere- 1, 1);
          letterAfter= substr( theLine, the2areBeginningHere+ 2, 1);
          if( testIt == "yes" ) {
            printf( "%s is =============================before \\\\\n", letterBefore);
            printf( "%s is after \\\\\n", letterAfter);
          }
          if( letterBefore == "\"" && letterBefore == "\"" ) {
            if( testIt == "yes" ) {
              printf( "\" is before \\\\\n" );
            }
            # don't modify the line
          } else {
            # modify the line
            theNewLine= substr( theLine, 1, the2areBeginningHere- 1);
            # pruefe nach <space> am Ende der Zeile
            theLine= theNewLine;
            if( testIt == "yes" ) {
              printf( "%d::%s::\n", NR, theLine);
            }
            lengthOfThePart= length( theLine);
            letter= substr( theLine, lengthOfThePart, 1);
            while( letter == " " ) {
              restOfTheLine= substr( theLine, 1, lengthOfThePart- 1);
              theLine= restOfTheLine;
              lengthOfThePart= length( theLine);
              letter= substr( theLine, lengthOfThePart, 1);
            }
            if( testIt == "yes" ) {
              printf( "%s/* guy */\n", theLine);
            }
          }
        }
        outputLine= theLine;
        #printf( "%s\n", theLine);
      } else {
        outputLine= theLine;
        #printf( "%s\n", theLine);
      }
    }
  } else {
    if( testIt == "yes" ) {
      printf( "im Kommentar\n" );
    }
    # look for the end of the comment */
    theCommentEndsHere= index( theLine, "*/" );
    if( theCommentEndsHere > 0) {
      if( testIt == "yes" ) {
        printf( "Ende gefunden\n" );
      }
      in_comment="no";
      outputLine= "";
      #printf( "\n" );
    } else {
      outputLine= "";
      #printf( "\n" );
    }
  }
  # print the outputLine
  printf( "%s\n", outputLine);
}
