BEGIN {
  previousLine= "";
}
{
  theLine= $0;
  # look for empty first line
  lengthOfTheLine= length( theLine);
  if( NR == 1) {
    if( lengthOfTheLine == 0) {
      #printf( "The first line is empty\n");
    } else {
      previousLine= theLine;
    }
  } else {
    printf( "%s\n", previousLine);
    previousLine= theLine;
  }
}
END {
  # for the last line
  if( lengthOfTheLine != 0) {
    printf( "%s\n", theLine);
  }
}
