#!/bin/bash
#
# Copyright 2013 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 2 february 2014
#
numberOfParameter=$#
if [ $numberOfParameter -eq 2 ] ;
then
  fileName=$2
  gawk -f $1 ${fileName} > kernel.tmp
else
  fileName=$3
  gawk -f $1 $2 ${fileName} > kernel.tmp
fi
if [ -s kernel.tmp ] ;
then
  echo "check the file "`pwd`/${fileName} 
  cat kernel.tmp
  echo ""
fi
rm kernel.tmp
